import { SimpleChanges, KeyValueDiffers } from '@angular/core';
import { NgZone, ElementRef } from '@angular/core';
import { OnDestroy, DoCheck, OnChanges, AfterViewInit } from '@angular/core';
import { EventEmitter } from '@angular/core';
import { Geometry, Position } from './perfect-scrollbar.interfaces';
import { PerfectScrollbarConfig, PerfectScrollbarConfigInterface } from './perfect-scrollbar.interfaces';
export declare class PerfectScrollbarDirective implements OnDestroy, DoCheck, OnChanges, AfterViewInit {
    private defaults;
    private zone;
    elementRef: ElementRef;
    private differs;
    private ps;
    private ro;
    private timeout;
    private configDiff;
    fxShow: boolean;
    fxHide: boolean;
    hidden: boolean;
    disabled: boolean;
    usePSClass: boolean;
    psPosStyle: string;
    runInsideAngular: boolean;
    config: PerfectScrollbarConfigInterface;
    oldConfig: PerfectScrollbarConfigInterface;
    PS_SCROLL_Y: EventEmitter<any>;
    PS_SCROLL_X: EventEmitter<any>;
    PS_SCROLL_UP: EventEmitter<any>;
    PS_SCROLL_DOWN: EventEmitter<any>;
    PS_SCROLL_LEFT: EventEmitter<any>;
    PS_SCROLL_RIGHT: EventEmitter<any>;
    PS_Y_REACH_END: EventEmitter<any>;
    PS_Y_REACH_START: EventEmitter<any>;
    PS_X_REACH_END: EventEmitter<any>;
    PS_X_REACH_START: EventEmitter<any>;
    private emit(event);
    psScrollY(event: any): void;
    psScrollX(event: any): void;
    psScrollUp(event: any): void;
    pscrollDown(event: any): void;
    psScrollLeft(event: any): void;
    psScrollRight(event: any): any;
    psReachEndY(event: any): any;
    psReachStartY(event: any): any;
    psReachEndX(event: any): any;
    psReachStartX(event: any): any;
    constructor(defaults: PerfectScrollbarConfig, zone: NgZone, elementRef: ElementRef, differs: KeyValueDiffers);
    ngOnDestroy(): void;
    ngDoCheck(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngAfterViewInit(): void;
    update(): void;
    geometry(prefix?: string): Geometry;
    position(absolute?: boolean): Position;
    scrollable(direction?: string): boolean;
    scrollTo(x: number, y?: number, speed?: number): void;
    scrollToX(x: number, speed?: number): void;
    scrollToY(y: number, speed?: number): void;
    scrollToTop(offset?: number, speed?: number): void;
    scrollToLeft(offset?: number, speed?: number): void;
    scrollToRight(offset?: number, speed?: number): void;
    scrollToBottom(offset?: number, speed?: number): void;
    animateScrolling(target: string, value: number, speed?: number): void;
}
